package self

import (
	"github.com/prometheus/client_golang/prometheus"
	"gitlab.com/gitlab-org/gitlab-metrics-exporter/internal/probe"
	"gitlab.com/gitlab-org/gitlab-metrics-exporter/internal/promclient"
)

type selfProbe struct{}

func NewProbe() probe.Probe {
	return &selfProbe{}
}

func (p *selfProbe) Probe(ch chan<- probe.ProbeResult) error {
	result, err := prometheus.DefaultGatherer.Gather()
	if err != nil {
		return err
	}

	for _, mf := range result {
		ch <- probe.ProbeResult{MGroup: *promclient.MetricFamilyToMetricGroup(mf)}
	}

	return nil
}
